#include "Sequencer.h"
#include <iostream>

Sequencer::Sequencer()
    : launchpad(), playbackScreen(*this), configScreen(*this), messages(),
      defaultOutputChannel(9), player(&midiOut, &beats, *this)
{
    playbackScreen.setLaunchpad(launchpad);
    configScreen.setLaunchpad(launchpad);
    beats.resize(midi::Launchpad::width - 1);
}

void Sequencer::run()
{
    std::cout << __func__ << std::endl;

    midiOut.openVirtualPort("launchpad sequencer");

    messages.resize(8);
    for(int i=0; i<messages.size(); i++) {
        messages[i] = std::make_shared<midi::NoteOnMessage>(defaultOutputChannel, 36 + i, 100 + i);
    }

    beats.resize(8);

    playbackScreen.enable();

    player.setBpm(256);

    std::cin.ignore();
}
